import { Sockpuppet } from "puppet/client";
import { Tail } from "npm:tail";

export function startTail(instance = "server") {
  return new Promise<[Tail, string]>((resolve) => {
    const puppet = new Sockpuppet("ws://sockpuppet.cyborggrizzly.com", () => {
      const channelId = crypto.randomUUID();
      puppet.createChannel(channelId);
      puppet.joinChannel(channelId, (line) => {
        console.log(line);
      });

      setTimeout(() => {
        const path = `./${instance}/logs/latest.log`;
        const tail = new Tail(path, { follow: true });

        tail.on("line", (line: string) => {
          puppet.getChannel(channelId)?.send(line);
          console.log(line);
        });
        resolve([tail, channelId]);
      }, 1000);
    });
  });
}
